VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorSharedModule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public row_ As Long
Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = FIRST_ROW)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = FIRST_ROW
End Function

Public Function GoLast()
  row_ = data_.Columns(S_S_NAME).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_S_NAME) = vbNullString
End Function

Public Function RemoveRow()
  Call data_.Rows(row_).Delete
End Function
  
'===== Propertiy Get =====
Public Property Get Name() As String
  Name = data_.Cells(row_, S_S_NAME)
End Property

Public Property Get ModuleType() As VBIDE.vbext_ComponentType
  ModuleType = data_.Cells(row_, S_S_TYPE)
End Property

Public Property Get Path() As String
  Path = data_.Cells(row_, S_S_PATH)
End Property

Public Property Get Version() As String
  Version = data_.Cells(row_, S_S_VERSION)
End Property

Public Property Get LoC() As Long
  LoC = data_.Cells(row_, S_S_LINES_TOTAL)
End Property

Public Property Get Declarations() As Long
  Declarations = data_.Cells(row_, S_S_LINES_DECLARATIONS)
End Property

Public Property Get CountAPI() As Long
  CountAPI = data_.Cells(row_, S_S_API_COUNT)
End Property

Public Property Get UsedIn() As String
  UsedIn = data_.Cells(row_, S_S_USAGE)
End Property

' ==== Property Let ====
Public Property Let Name(newVal$)
  data_.Cells(row_, S_S_NAME) = newVal
End Property

Public Property Let ModuleType(newVal As VBIDE.vbext_ComponentType)
  data_.Cells(row_, S_S_TYPE) = newVal
End Property

Public Property Let Path(newVal$)
  data_.Cells(row_, S_S_PATH) = newVal
End Property

Public Property Let Version(newVal$)
  data_.Cells(row_, S_S_VERSION) = newVal
End Property

Public Property Let LoC(newVal&)
  data_.Cells(row_, S_S_LINES_TOTAL) = newVal
End Property

Public Property Let Declarations(newVal&)
  data_.Cells(row_, S_S_LINES_DECLARATIONS) = newVal
End Property

Public Property Let CountAPI(newVal&)
  data_.Cells(row_, S_S_API_COUNT) = newVal
End Property

Public Property Let UsedIn(newVal$)
  data_.Cells(row_, S_S_USAGE) = newVal
End Property
