VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public row_ As Long
Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = FIRST_ROW)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = FIRST_ROW
End Function

Public Function GoLast()
  row_ = data_.Columns(S_T_PRODUCT).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_T_PRODUCT) = vbNullString
End Function

Public Function RemoveRow()
  Call data_.Rows(row_).Delete
End Function

Public Function PushTestResult(sSuite$, sTest$, bResult As Boolean, sMsg$, dDuration As Double)
  TestSuite = sSuite
  TestName = sTest
  Status = bResult
  Message = sMsg
  DDate = Now
  Duration = dDuration
  
  Call Increment
  Product = data_.Cells(row_ - 1, S_T_PRODUCT)
  Component = data_.Cells(row_ - 1, S_T_COMPONENT)
End Function

'===== Propertiy Get =====
Public Property Get Product() As String
  Product = data_.Cells(row_, S_T_PRODUCT)
End Property

Public Property Get Component() As String
  Component = data_.Cells(row_, S_T_COMPONENT)
End Property

Public Property Get TestSuite() As String
  TestSuite = data_.Cells(row_, S_T_SUITE)
End Property

Public Property Get TestName() As String
  TestName = data_.Cells(row_, S_T_TEST)
End Property

Public Property Get DDate() As Double
  DDate = data_.Cells(row_, S_T_DATE)
End Property

Public Property Get Duration() As Double
  DDate = data_.Cells(row_, S_T_DURATION)
End Property

Public Property Get Status() As Boolean
  Status = data_.Cells(row_, S_T_STATUS) = 1
End Property

Public Property Get Message() As String
  Message = data_.Cells(row_, S_T_MESSAGE)
End Property

' ==== Property Let ====
Public Property Let Product(newVal$)
  data_.Cells(row_, S_T_PRODUCT) = newVal
End Property

Public Property Let Component(newVal$)
  data_.Cells(row_, S_T_COMPONENT) = newVal
End Property

Public Property Let TestSuite(newVal$)
  data_.Cells(row_, S_T_SUITE) = newVal
End Property

Public Property Let TestName(newVal$)
  data_.Cells(row_, S_T_TEST) = newVal
End Property

Public Property Let DDate(newVal As Double)
  data_.Cells(row_, S_T_DATE) = newVal
End Property

Public Property Let Duration(newVal As Double)
  data_.Cells(row_, S_T_DURATION) = newVal
End Property

Public Property Let Status(newVal As Boolean)
  data_.Cells(row_, S_T_STATUS) = IIf(newVal, 1, 0)
End Property

Public Property Let Message(newVal$)
  data_.Cells(row_, S_T_MESSAGE) = newVal
End Property
