Attribute VB_Name = "DevHelper"
Option Explicit

Public Const TEST_TARGET_FOLDER = "testFiles"
Public Const TEST_ARTIFACT_FOLDER = "test"

Public Const TEST_WORD_TEMPLATE = "testTemplate.dotx"
Public Const TEST_WORD_DOCUMENT = "TestWord.docx"
Public Const TEST_WORD_INVALID = "TestInvalid.docx"

Public Function Dev_PrepareSkeleton()
  ' Do nothing
End Function

Public Sub Dev_ManualRunTest()
  Dim sSuite$: sSuite = "s_Path"
  Dim sTest$: sTest = "t_ToLocal"
  Dim sMsg$: sMsg = Dev_RunTestDebug(sSuite, sTest)
  Debug.Print sMsg
  Call MsgBox(sMsg)
End Sub

Public Function Dev_GetTestSuite(sName$) As Object
  Select Case sName
    Case "s_Config": Set Dev_GetTestSuite = New s_Config
    Case "s_JSON": Set Dev_GetTestSuite = New s_JSON
    Case "s_Path": Set Dev_GetTestSuite = New s_Path
    Case "s_CompoundIntervals": Set Dev_GetTestSuite = New s_CompoundIntervals
    Case "s_ExColor": Set Dev_GetTestSuite = New s_ExColor
    Case "s_StaticHierarchy": Set Dev_GetTestSuite = New s_StaticHierarchy
    Case "s_ParseDate": Set Dev_GetTestSuite = New s_ParseDate
    Case "s_ExCollection": Set Dev_GetTestSuite = New s_ExCollection
    Case "s_ExVBA": Set Dev_GetTestSuite = New s_ExVBA
    Case "s_ExHash": Set Dev_GetTestSuite = New s_ExHash
    Case "s_Logger": Set Dev_GetTestSuite = New s_Logger
    Case "s_WordWrapper": Set Dev_GetTestSuite = New s_WordWrapper
    Case "s_XLWrapper": Set Dev_GetTestSuite = New s_XLWrapper
    Case "s_VsoWrapper": Set Dev_GetTestSuite = New s_VsoWrapper
    Case "s_ExWinAPI": Set Dev_GetTestSuite = New s_ExWinAPI
    Case "s_Graph": Set Dev_GetTestSuite = New s_Graph
  End Select
End Function

Public Function Dev_GetTestFolder() As String
  Static sFolder$
  If sFolder = vbNullString Then
    sFolder = ThisWorkbook.Path & "\" & TEST_TARGET_FOLDER
  End If
  Dev_GetTestFolder = sFolder
End Function

Public Function Dev_GetArtifactFolder() As String
  Static sFolder$
  If sFolder = vbNullString Then
    sFolder = ThisWorkbook.Path & "\" & TEST_ARTIFACT_FOLDER
  End If
  Dev_GetArtifactFolder = sFolder
End Function

