VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_Factorizator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ===== Test suite for Factorizator =======
Option Explicit

Private factors_ As CDS_Factorizator

Public Function Setup()
  ' Mandatory setup function
  Set factors_ = New CDS_Factorizator
End Function

Public Function Teardown()
  ' Mandatory teardown function
End Function

Public Function t_Access()
  On Error GoTo PROPAGATE_ERROR
    
  Call Dev_NewCase("Empty input")
  Call factors_.Init(0)
  Call Dev_ExpectEQ(CSet(), factors_.Values)
  Call Dev_ExpectEQ(Empty, factors_.FactorFor(1337))
  Call Dev_ExpectEQ(0, factors_.FactorValueFor(1337))
  
  Call Dev_NewCase("Access valid items")
  Call Dev_AssertTrue(factors_.Insert(1337, 1))
  Call Dev_AssertFalse(factors_.Insert(1337, 3), "Duplicate inserts")
  Call Dev_AssertTrue(factors_.Insert(42, 2))
  Dim iVals As New Scripting.Dictionary
  iVals(1337) = 1
  iVals(42) = 2
  Call Dev_ExpectEQ(iVals, factors_.Values)
  Call Dev_ExpectEQ(1337, factors_.FactorFor(1337))
  Call Dev_ExpectEQ(1, factors_.FactorValueFor(1337))
  Call Dev_ExpectEQ(42, factors_.FactorFor(42))
  Call Dev_ExpectEQ(2, factors_.FactorValueFor(42))
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function

Public Function t_Factorization()
  On Error GoTo PROPAGATE_ERROR
  
  Call Dev_NewCase("Maximum gap")
  Call factors_.Init(10)
  Call factors_.Insert(1, 1)
  Call factors_.Insert(2, 11)
  Call Dev_ExpectEQ(2, factors_.FactorFor(1))
  Call Dev_ExpectEQ(2, factors_.FactorFor(2))
  
  Call Dev_NewCase("Minimal increment")
  Call factors_.Insert(3, 11 + 0.001)
  Call Dev_ExpectEQ(3, factors_.FactorFor(3))
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
