VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_VsoGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ===== Test suite for Visio Graph scanner =======
Option Explicit

' TODO:
' Public Function ScanGraph(iSeed As Collection, bReverseLinks As Boolean) As CDS_Graph

Private page_ As Visio.Page

Public Function Setup()
  ' Mandatory setup function
  Set page_ = ThisDocument.Pages(1)
  ThisDocument.DiagramServicesEnabled = visServiceStructureFull
End Function

Public Function Teardown()
  ' Mandatory teardown function
  ThisDocument.DiagramServicesEnabled = 0
  Call ClearAll
End Function

Public Function t_ScanConnector()
  On Error GoTo PROPAGATE_ERROR
  
  Dim iResult As ItemConnector
  
  Call Dev_NewCase("Free arrow")
  Dim iArrow As Visio.Shape: Set iArrow = page_.Drop(FindMaster(ThisDocument, MASTER_CONNECTOR), 30, 30)
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectNothing(iResult.begin_)
  Call Dev_ExpectNothing(iResult.end_)
  Call Dev_ExpectEQ(T_CD_STRAIGHT, iResult.dir_)
  
  Call Dev_NewCase("Arrow directions")
  iArrow.CellsU("BeginArrow") = 9
  iArrow.CellsU("EndArrow") = 9
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectEQ(T_CD_NONE, iResult.dir_)
  
  iArrow.CellsU("BeginArrow") = 9
  iArrow.CellsU("EndArrow") = 1
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectEQ(T_CD_STRAIGHT, iResult.dir_)
  
  iArrow.CellsU("BeginArrow") = 1
  iArrow.CellsU("EndArrow") = 9
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectEQ(T_CD_REVERSE, iResult.dir_)
  
  iArrow.CellsU("BeginArrow") = 1
  iArrow.CellsU("EndArrow") = 1
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectEQ(T_CD_MUTUAL, iResult.dir_)
  
  Call Dev_NewCase("Attached shapes")
  Dim elem1 As Visio.Shape: Set elem1 = page_.Drop(FindMaster(ThisDocument, MASTER_ELEMENT), 10, 10)
  Dim elem2 As Visio.Shape: Set elem2 = page_.Drop(FindMaster(ThisDocument, MASTER_ELEMENT), 20, 20)
  iArrow.CellsU("BeginArrow") = 9
  iArrow.CellsU("EndArrow") = 1
  
  Call iArrow.CellsU("BeginX").GlueTo(elem1.CellsU("PinX"))
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectEQ(elem1, iResult.begin_)
  Call Dev_ExpectNothing(iResult.end_)
  
  Call iArrow.Disconnect(visConnectorBothEnds, 0, 0, visFeet)
  Call iArrow.CellsU("EndX").GlueTo(elem2.CellsU("PinX"))
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectNothing(iResult.begin_)
  Call Dev_ExpectEQ(elem2, iResult.end_)
  
  Call iArrow.CellsU("BeginX").GlueTo(elem1.CellsU("PinX"))
  Call iArrow.CellsU("EndX").GlueTo(elem2.CellsU("PinX"))
  iResult = ScanConnector(iArrow)
  Call Dev_ExpectEQ(elem1, iResult.begin_)
  Call Dev_ExpectEQ(elem2, iResult.end_)
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
