VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_XLWrapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Note: Testing only functions different from API_WordWrapper
' TODO: test OpenDocument with ignore folder

Private xl_ As API_XLWrapper
Private fso_ As Scripting.FileSystemObject

Public Function Setup()
  ' Mandatory setup function
  Set xl_ = New API_XLWrapper
  Call xl_.DisableMessages
  Call xl_.CreateApplication
  Set fso_ = New Scripting.FileSystemObject
  Call EnsureFolderExists(Dev_GetTestFolder)
End Function

Public Function Teardown()
  ' Mandatory teardown function
  Call fso_.DeleteFolder(Dev_GetTestFolder)
  Call xl_.ReleaseApplication
  Set xl_ = Nothing
End Function

Public Function t_SaveAs()
  On Error GoTo PROPAGATE_ERROR
  
  Dim sTemplate$: sTemplate = Dev_GetTestFolder & "\" & "testFile"
  Dim sText$: sText = "TestWord"
  Dim sTarget$
  Dim oReader As New API_XLWrapper
  Call oReader.CreateApplication
  Call oReader.DisableMessages

  Call Dev_NewCase("No document")
  On Error Resume Next
  Call Dev_ExpectFalse(xl_.SaveAs(sTemplate & ".xlsx"))
  Call Dev_ExpectNoError
  On Error Resume Next
  
  Call xl_.NewDocument
  xl_.Document.Worksheets(1).Cells(1, 1) = sText
  Call Dev_ExpectFalse(xl_.SaveAs("invalid!?"), "Invalid filename")

  Call Dev_NewCase("Save as xlsx")
  sTarget = sTemplate & ".xlsx"
  Call Dev_ExpectTrue(xl_.SaveAs(sTarget))
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget, bReadOnly:=True), "Open saved document")
  Call Dev_ExpectEQ(sText, oReader.Document.Worksheets(1).Cells(1, 1).Text, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call Dev_NewCase("Save as xlsm")
  sTarget = sTemplate & ".xlsm"
  Call Dev_ExpectTrue(xl_.SaveAs(sTarget))
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget, bReadOnly:=True), "Open saved document")
  Call Dev_ExpectEQ(sText, oReader.Document.Worksheets(1).Cells(1, 1).Text, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call Dev_NewCase("Save as xltx")
  sTarget = sTemplate & ".xltx"
  Call Dev_ExpectTrue(xl_.SaveAs(sTarget))
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget, bReadOnly:=True), "Open saved document")
  Call Dev_ExpectEQ(sText, oReader.Document.Worksheets(1).Cells(1, 1).Text, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call Dev_NewCase("Save as xltm")
  sTarget = sTemplate & ".xltm"
  Call Dev_ExpectTrue(xl_.SaveAs(sTarget))
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget, bReadOnly:=True), "Open saved document")
  Call Dev_ExpectEQ(sText, oReader.Document.Worksheets(1).Cells(1, 1).Text, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call Dev_NewCase("Save as xlam")
  sTarget = sTemplate & ".xlam"
  Call Dev_ExpectTrue(xl_.SaveAs(sTarget))
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget, bReadOnly:=True), "Open saved document")
  Call Dev_ExpectEQ(sText, oReader.Document.Worksheets(1).Cells(1, 1).Text, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call xl_.ReleaseDocument
  Call oReader.ReleaseApplication
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
